package thehippomaster.animationapi.client.model.wavefront;

public class Normal
{
  public float x;
  public float y;
  public float z;
  
  public Normal(float x, float y, float z)
  {
    this.x = x;
    this.y = y;
    this.z = z;
  }
  
  public Normal(String[] value)
  {
    this.x = Float.parseFloat(value[0]);
    this.y = Float.parseFloat(value[1]);
    this.z = Float.parseFloat(value[2]);
  }
  
  public Normal(Vertex o, Vertex a, Vertex b)
  {
    float a_x = a.x - o.x;
    float a_y = a.y - o.y;
    float a_z = a.z - o.z;
    float b_x = b.x - o.x;
    float b_y = b.y - o.y;
    float b_z = b.z - o.z;
    this.x = (a_y * b_z - a_z * b_y);
    this.y = (a_z * b_x - a_x * b_z);
    this.z = (a_x * b_y - a_y * b_x);
    float norme = (float)Math.sqrt(this.x * this.x + this.y * this.y + this.z * this.z);
    this.x /= norme;
    this.y /= norme;
    this.z /= norme;
  }
}
